<!DOCTYPE html>

<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="generator" content="Docutils 0.5: http://docutils.sourceforge.net/">
<title>Bitten: Upgrading</title>
<link rel="stylesheet" href="common/style/edgewall.css" type="text/css">
</head>
<body>
<div class="document" id="upgrading">
    <div id="navigation">
      <span class="projinfo">Bitten 0.6</span>
      <a href="index.html">Documentation Index</a>
    </div>
<h1 class="title">Upgrading</h1>
<div class="contents topic" id="contents">
<p class="topic-title first">Contents</p>
<ul class="auto-toc simple">
<li><a class="reference internal" href="#removing-duplicate-builds" id="id1">1   Removing Duplicate Builds</a></li>
<li><a class="reference internal" href="#reporting-upgrade-issues" id="id2">2   Reporting Upgrade Issues</a></li>
<li><a class="reference internal" href="#upgrade-history" id="id3">3   Upgrade history</a></li>
</ul>
</div>
<p>Bitten's database schema is versioned using the <cite>bitten_version</cite> entry in
Trac's system table. If you install a version of Bitten with a more recent
schema you will need to run <cite>trac-admin update</cite> after installing Bitten to
update your database. Until this done Trac will not activate your new
Bitten installation.</p>
<div class="note">
<p class="first admonition-title">Note</p>
<p class="last">You should back up your Trac database and Trac environment before running
<cite>trac-admin upgrade</cite>.</p>
</div>
<div class="note">
<p class="first admonition-title">Note</p>
<p class="last">If you are using a SQLite database file, Trac automatically creates a copy
before proceeding with the update. This should not be relied upon but can
be useful if you have ignored the advice above.</p>
</div>
<p>Bitten's upgrade scripts attempt to commit changes made to the database each
time a new schema version is reached. This ensures that if an upgrade fails
to complete the Bitten database is left in the most up-to-date state possible.</p>
<p>For example, if you were upgrading from Bitten schema 6 to schema version 12
and duplicate builds were found during the attempt to upgrade to schema 10, your
database would be left at schema 9.</p>
<div class="section" id="removing-duplicate-builds">
<h1>1   Removing Duplicate Builds</h1>
<p>Bitten schema version 10 adds a unique index on the columns
<cite>(config, platform, rev)</cite> to the <cite>bitten_build</cite> table. This constraint is
relied on by Bitten but was not enforced in earlier versions and duplicate
builds could arise. Before the upgrade to schema version 10 can complete, these
duplicate builds must be removed. The <cite>trac-admin upgrade</cite> will produce a list
of duplicates but the decision on which to keep remains with the user.</p>
<p>A <a class="reference external" href="http://bitten.edgewall.org/browser/trunk/contrib/deletebuild.py">script</a> for removing builds is provided. This scripts supports schema
versions 9 through 12.</p>
</div>
<div class="section" id="reporting-upgrade-issues">
<h1>2   Reporting Upgrade Issues</h1>
<p>Debugging upgrade issues can be difficult since the Bitten development team
does not have access to your database.  Attaching a description of your
database schema before and after running <cite>trac-admin upgrade</cite> to your
request for assistance may help others diagnose the problem more swiftly.</p>
<p>You can create such a schema description using <a class="reference external" href="http://pypi.python.org/pypi/gerald">Gerald</a> or a similar tool.</p>
</div>
<div class="section" id="upgrade-history">
<h1>3   Upgrade history</h1>
<p>The current version of the Bitten schema is version 12.</p>
<div class="section" id="version-12">
<h2>3.1   Version 12</h2>
<ul class="simple">
<li><cite>last activity</cite> column added to <cite>bitten_build</cite>.</li>
</ul>
</div>
<div class="section" id="version-11">
<h2>3.2   Version 11</h2>
<ul class="simple">
<li>Badly named log level files that ended with <cite>.log.level</cite> created by earlier
versions of Bitten were renamed to end in <cite>.log.levels</cite> which is the correct
extension.</li>
<li>Log level files that had not been correctly deleted by earlier versions of
Bitten were cleaned up.</li>
</ul>
</div>
<div class="section" id="version-10">
<h2>3.3   Version 10</h2>
<ul class="simple">
<li>PostgreSQL sequences on the <cite>id</cite> column that had not been correctly updated
by previous Bitten upgrade scripts were corrected. This affected four tables:
<cite>bitten_build</cite>, <cite>bitten_log</cite>, <cite>bitten_platform</cite> and <cite>bitten_report</cite>.</li>
<li>A unique index on the columns <cite>(config, platform, rev)</cite> was added to the
<cite>bitten_build</cite> table and an old unique index on <cite>(config, rev, slave)</cite> was
removed.</li>
</ul>
<div class="note">
<p class="first admonition-title">Note</p>
<p class="last">The lack of an index on <cite>(config, platform, rev)</cite> in ealier versions of
Bitten allowed duplicate builds to be created in the database under some
conditions. These duplicate builds need to be manually removed before the
upgrade to version 10 can complete.</p>
</div>
</div>
<div class="section" id="version-9">
<h2>3.4   Version 9</h2>
<ul class="simple">
<li>The <cite>id</cite> column of the <cite>bitten_rule</cite> table was converted from a text column
to an integer one.</li>
</ul>
</div>
<div class="section" id="version-8">
<h2>3.5   Version 8</h2>
<ul class="simple">
<li>Log messages that had been stored in the <cite>bitten_log_messages</cite> table were
migrated to files.</li>
<li>A <cite>filename</cite> field was added to the <cite>bitten_log</cite> table to record the
location of the new log files.</li>
</ul>
</div>
<div class="section" id="version-7">
<h2>3.6   Version 7</h2>
<ul class="simple">
<li>The <cite>bitten_error</cite> table as added to record the reasons for step failures.</li>
</ul>
</div>
<div class="section" id="version-6">
<h2>3.7   Version 6</h2>
<ul class="simple">
<li>Filenames stored in the <cite>value</cite> column of <cite>bitten_report_item</cite> where
normalized to use <cite>/</cite> as the path separator.</li>
<li>The <cite>generator</cite> columns in <cite>bitten_log</cite> and <cite>bitten_report</cite> previously
stored just the short tag name of the associated generator. These were
updated to store the full tag name of the generator (including the XML
namespace). For example, <cite>pipe</cite> was changed to
<cite>http://bitten.edgewall.org/tools/sh#pipe</cite>.</li>
</ul>
</div>
<div class="section" id="version-5">
<h2>3.8   Version 5</h2>
<ul class="simple">
<li>An <cite>orderno</cite> column was added to the <cite>bitten_log</cite> table to record the
order in which sets of log messages were generated.</li>
<li>The <cite>bitten_report</cite> and <cite>bitten_report_item</cite> tables were added to record
reports generated by unit tests and other build tools.</li>
<li>Report data was imported from the old Berkeley DB XML store into the new
database tables.</li>
</ul>
</div>
<div class="section" id="version-4">
<h2>3.9   Version 4</h2>
<ul class="simple">
<li>The build configuration that generated a report was added to the report
metadata in the Berkeley DB XML store.</li>
</ul>
</div>
<div class="section" id="version-3">
<h2>3.10   Version 3</h2>
<ul class="simple">
<li>The <cite>recipe</cite> column was added to <cite>bitten_config</cite> to store the recipe XML.</li>
</ul>
</div>
<div class="section" id="version-2">
<h2>3.11   Version 2</h2>
<ul class="simple">
<li>The <cite>bitten_log</cite> and <cite>bitten_log_message</cite> tables were created for storing
log messages.</li>
<li>The <cite>log</cite> column was removed from <cite>bitten_step</cite> and the log messages where
migrated to the two new logging tables.</li>
</ul>
</div>
<div class="section" id="version-1">
<h2>3.12   Version 1</h2>
<ul class="simple">
<li>The first Bitten database schema.</li>
</ul>
</div>
</div>
    <div id="footer">
      Visit the Bitten open source project at
      <a href="http://bitten.edgewall.org/">http://bitten.edgewall.org/</a>
    </div>
  </div>
</body>
</html>
